// FT2232CI2CC++NETTestApp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <windows.h>

#include "FTCI2C.h"

#define MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES 512

#define NUM_M24C64_PAGES 1
#define NUM_M24C64_BYTES_PER_PAGE 32

#define MAX_FREQ_M24C64_CLOCK_DIVISOR 15   // equivalent to 400KHz
//#define MAX_FREQ_M24C64_CLOCK_DIVISOR 60   // equivalent to 100KHz

int _tmain(int argc, _TCHAR* argv[])
{
  FTC_STATUS Status = FTC_SUCCESS;
  DWORD dwNumDevices = 0;
  char szDeviceName[100];
  DWORD dwLocationID = 0;
  FTC_HANDLE ftHandle;
  DWORD dwClockFrequencyHz = 0;
  BYTE DataByte = 0;
  BYTE DataByteWritten = 0;
  DWORD dwCharCntr = 0;
  DWORD DataWriteType = 0;
  DWORD dwWriteDataBufferIndex = 0;
  WriteControlByteBuffer WriteControlBuffer;
  WriteDataByteBuffer WriteDataBuffer;
  DWORD dwNumDataBytesToWrite = 0;
  FTC_PAGE_WRITE_DATA PageWriteData;
  DWORD dwWriteDataByteAddress = 0;
  DWORD DataReadType = 0;
  ReadDataByteBuffer ReadDataBuffer;
  DWORD dwNumDataBytesToRead = 0;
  DWORD dwReadDataByteAddress = 0;
  ReadDataByteBuffer ReadData;
  DWORD dwReadDataIndex = 0;
  int MsgBoxKeyPressed = 0;
  DWORD dwLoopCntr = 0;
  char szDllVersion[10];
  char szTitleErrorMessage[100];
  char szErrorMessage[100];

  Status = I2C_GetNumDevices(&dwNumDevices);

  //Status = I2C_GetDllVersion(szDllVersion, 10);

  if ((Status == FTC_SUCCESS) && (dwNumDevices > 0))
  {
    if (dwNumDevices == 1)
    {
      Status = I2C_GetDeviceNameLocID(0, szDeviceName, 100, &dwLocationID);

      if (Status == FTC_SUCCESS)
      {
        Status = I2C_OpenEx(szDeviceName, dwLocationID, &ftHandle);
        //Status = I2C_Open(&ftHandle);
      }
    }
    else
    {
      if (dwNumDevices == 2)
      {
        Status = I2C_GetDeviceNameLocID(1, szDeviceName, 50, &dwLocationID);

        if (Status == FTC_SUCCESS)
        {
          Status = I2C_OpenEx(szDeviceName, dwLocationID, &ftHandle);
          //Status = I2C_Open(&ftHandle);
        }
      }
    }
  }

  if ((Status == FTC_SUCCESS) && (dwNumDevices > 0))
  {
    if (Status == FTC_SUCCESS)
      Status = I2C_GetClock(MAX_FREQ_M24C64_CLOCK_DIVISOR, &dwClockFrequencyHz);

    //if (Status == FTC_SUCCESS)
    //  Status = I2C_SetLoopback(ftHandle, true);

    if (Status == FTC_SUCCESS)
    {
      //if (Status == FTC_SUCCESS)
        //Status = I2C_SetClock(ftHandle, 0, &dwClockFrequencyHz);

      if (Status == FTC_SUCCESS)
      {
        Status = I2C_InitDevice(ftHandle, MAX_FREQ_M24C64_CLOCK_DIVISOR); //65535

        if (Status == FTC_SUCCESS)
          Status = I2C_SetMode(ftHandle, FAST_MODE);

        if (Status == FTC_SUCCESS)
        {
          WriteControlBuffer[0] = '\xAE'; //1 0 1 0 A2 A1 A0 0 - device address 7

          WriteDataBuffer[0] = '\xFF';  // Erase address locations

          dwWriteDataByteAddress = 0;

          do
          {
            // shift down by 8 bits
            WriteControlBuffer[1] = ((dwWriteDataByteAddress >> 8) & '\xFF');
            WriteControlBuffer[2] = (dwWriteDataByteAddress & '\xFF');

            Status = I2C_Write(ftHandle, &WriteControlBuffer, 3, true, 20, true, BYTE_WRITE_TYPE,
                               &WriteDataBuffer, 1, true, 20, &PageWriteData);

            dwWriteDataByteAddress++;
          }
          while ((dwWriteDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) && (Status == FTC_SUCCESS));

          Sleep(200);
        }

        DataByte = 0; //'\x77';

        if (Status == FTC_SUCCESS)
        {
          //do
          //{
            Status = I2C_InitDevice(ftHandle, MAX_FREQ_M24C64_CLOCK_DIVISOR); //65535

            if (Status == FTC_SUCCESS)
            {
              WriteControlBuffer[0] = '\xAE'; //1 0 1 0 A2 A1 A0 0 - device address 7

              dwWriteDataByteAddress = 0;

              DataWriteType = PAGE_WRITE_TYPE; //BYTE_WRITE_TYPE;

              if (DataWriteType == BYTE_WRITE_TYPE)
              {
                WriteDataBuffer[0] = DataByte;

                dwNumDataBytesToWrite = 1;
              }
              else
              {
                WriteDataBuffer[0] = DataByte;

                PageWriteData.dwNumPages = NUM_M24C64_PAGES;
                PageWriteData.dwNumBytesPerPage = NUM_M24C64_BYTES_PER_PAGE;

                dwNumDataBytesToWrite = (NUM_M24C64_PAGES * NUM_M24C64_BYTES_PER_PAGE);

                if (DataByte == 0)
                {
                  for (dwWriteDataBufferIndex = 0; dwWriteDataBufferIndex < dwNumDataBytesToWrite; dwWriteDataBufferIndex++)
                    WriteDataBuffer[dwWriteDataBufferIndex] = dwWriteDataBufferIndex;
                }
                else
                {
                  for (dwWriteDataBufferIndex = 1; dwWriteDataBufferIndex < dwNumDataBytesToWrite; dwWriteDataBufferIndex++)
                    WriteDataBuffer[dwWriteDataBufferIndex] = DataByte;
                }
              }

              do
              {
                // shift down by 8 bits
                WriteControlBuffer[1] = ((dwWriteDataByteAddress >> 8) & '\xFF');
                WriteControlBuffer[2] = (dwWriteDataByteAddress & '\xFF');

                Status = I2C_Write(ftHandle, &WriteControlBuffer, 3, true, 20, true, DataWriteType,
                                   &WriteDataBuffer, dwNumDataBytesToWrite, true, 20, &PageWriteData);

                if (DataWriteType == BYTE_WRITE_TYPE)
                {
                  dwWriteDataByteAddress++;

                  if (DataByte == 0)
                    WriteDataBuffer[0] = dwWriteDataByteAddress;
                }
                else
                {
                  dwWriteDataByteAddress = dwWriteDataByteAddress + (NUM_M24C64_PAGES * NUM_M24C64_BYTES_PER_PAGE);

                  if (DataByte == 0)
                  {
                    for (dwWriteDataBufferIndex = 0; dwWriteDataBufferIndex < dwNumDataBytesToWrite; dwWriteDataBufferIndex++)
                      WriteDataBuffer[dwWriteDataBufferIndex] = (dwWriteDataByteAddress + dwWriteDataBufferIndex);
                  }
                }
              }
              while ((dwWriteDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) && (Status == FTC_SUCCESS));
            }

          do
          {
            Sleep(200);

            //if (Status == FTC_SUCCESS)
            //  Status = I2C_InitDevice(ftHandle, MAX_FREQ_M24C64_CLOCK_DIVISOR);

            if (Status == FTC_SUCCESS)
            {
              WriteControlBuffer[0] = '\xAF'; //1 0 1 0 A2 A1 A0 1 - device address 7

              for (dwReadDataIndex = 0; dwReadDataIndex < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES; dwReadDataIndex++)
                ReadData[dwReadDataIndex] = 0;

              dwReadDataByteAddress = 0;

              DataReadType = BYTE_READ_TYPE; //BLOCK_READ_TYPE; //

              if (DataReadType == BYTE_READ_TYPE)
                dwNumDataBytesToRead = 1;
              else
                dwNumDataBytesToRead = MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES;

              do
              {
                // shift down by 8 bits
                WriteControlBuffer[1] = ((dwReadDataByteAddress >> 8) & '\xFF');
                WriteControlBuffer[2] = (dwReadDataByteAddress & '\xFF');

                Status = I2C_Read(ftHandle, &WriteControlBuffer, 3, true, 20, DataReadType, &ReadDataBuffer, dwNumDataBytesToRead);
                //Status = I2C_Read(ftHandle, &WriteControlBuffer, 2, false, 10, DataReadType, &ReadDataBuffer, 1);

                if (Status == FTC_SUCCESS)
                {
                  if (DataReadType == BYTE_READ_TYPE)
                    ReadData[dwReadDataByteAddress] = ReadDataBuffer[0];
                  else
                  {
                    for (dwReadDataIndex = 0; dwReadDataIndex < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES; dwReadDataIndex++)
                      ReadData[dwReadDataIndex] = ReadDataBuffer[dwReadDataIndex];
                  }
                }

                if (DataReadType == BYTE_READ_TYPE)
                  dwReadDataByteAddress++;
                else
                  dwReadDataByteAddress = dwReadDataByteAddress + MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES;
              }
              while ((dwReadDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) && (Status == FTC_SUCCESS));

              if (Status == FTC_SUCCESS)
              {
                MsgBoxKeyPressed = IDOK;

                for (dwReadDataIndex = 0; ((dwReadDataIndex < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) && (MsgBoxKeyPressed == IDOK)); dwReadDataIndex++)
                {
                  if (DataByte != 0)
                    DataByteWritten = DataByte;
                  else
                    DataByteWritten = (dwReadDataIndex & '\xFF');

                  if (((ReadData[dwReadDataIndex] != DataByteWritten) && (DataByte != 0)) ||
                      ((ReadData[dwReadDataIndex] != DataByteWritten) && (DataByte == 0)))
                  {
                    for (dwCharCntr = 0; (dwCharCntr < 100); dwCharCntr++)
                      szErrorMessage[dwCharCntr] = '\0';

                    sprintf(szErrorMessage, "I2C M24C64 Read/Write mismatch, Address = %i, Write Value = %X, Read Value = %X", dwReadDataIndex, DataByteWritten, ReadData[dwReadDataIndex]);
                    MsgBoxKeyPressed = MessageBox(NULL, szErrorMessage, "I2C Read Error Message", MB_OK | MB_OKCANCEL);
                  }
                }
              }
            }

            dwLoopCntr++;
          }
          while ((dwLoopCntr < 10000) && (Status == FTC_SUCCESS));
        }
      }
    }

    I2C_Close(ftHandle);
  }

  if (Status != FTC_SUCCESS)
  {
    Status = I2C_GetErrorCodeString("EN", Status, szErrorMessage, 100);

    sprintf(szTitleErrorMessage, "%s%d", "I2C Error Status Message, Loop No = ", dwLoopCntr);

    MessageBox(NULL, szErrorMessage, "I2C Error Status Message", MB_OK);
  }
  else
  {
    Status = I2C_GetDllVersion(szDllVersion, 10);

    //if (Status == FTC_SUCCESS)
      //MessageBox(NULL, szDllVersion, "I2C DLL Version", MB_OK);
    //else
    //{
      //Status = I2C_GetErrorCodeString("EN", Status, szErrorMessage, 100);

      //MessageBox(NULL, szErrorMessage, "I2C Error Status Message", MB_OK);
    //}
  }

	return 0;
}

